import { HttpStatus } from '@nestjs/common';
import { AppService } from './app.service';
import { Logger } from 'winston';
import { Response } from 'express';
export declare class AppController {
    private readonly appService;
    private logger;
    constructor(appService: AppService, logger: Logger);
    getHello(): string;
    downloadFile(filename: string, req: any, res: Response): Promise<void>;
    getImage(image: string, req: any, res: Response): Promise<void | {
        status: HttpStatus;
        message: string;
    }>;
    getTermsAndCondition(res: Response, req: any): Promise<Response<any, Record<string, any>>>;
    getPrivacyPolicy(res: Response, req: any): Promise<Response<any, Record<string, any>>>;
}
