"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserController = void 0;
const common_1 = require("@nestjs/common");
const user_service_1 = require("./user.service");
const create_user_dto_1 = require("./dto/create-user.dto");
const commonServices_1 = require("../services/commonServices");
const passport_1 = require("@nestjs/passport");
const path_1 = require("path");
const platform_express_1 = require("@nestjs/platform-express");
const multer_1 = require("multer");
let UserController = class UserController {
    constructor(userService, commonServices) {
        this.userService = userService;
        this.commonServices = commonServices;
    }
    async registerUser(userData, res, req) {
        return this.userService.registerUser(userData, res);
    }
    async userLogin(userData, res, req) {
        return this.userService.userLogin(userData, res);
    }
    async forgotPassword(userData, res, req) {
        return this.userService.forgotPassword(userData, res);
    }
    async verifyOtp(userData, res, req) {
        return this.userService.verifyOtp(userData, res);
    }
    async changePassword(userData, res, req) {
        return this.userService.changePassword(userData, res);
    }
    async updateProfile(userData, file, res, req) {
        if (req.user.isUser === true) {
            let isValid = await this.commonServices.checkToken(req.headers.authorization.split(' ')[1]);
            if (isValid === false) {
                throw new common_1.UnauthorizedException();
            }
            if (req.file) {
                userData.profile_image = file.filename;
            }
            return this.userService.updateProfile(userData, req.user.userId, res);
        }
        else {
            throw new common_1.UnauthorizedException();
        }
    }
    async logout(userData, res, req) {
        if (req.user.isUser === true) {
            let token = req.headers.authorization.split(' ')[1];
            let isValid = await this.commonServices.checkToken(token);
            if (isValid === false) {
                throw new common_1.UnauthorizedException();
            }
            return this.userService.logout(req.user.userId, token, res);
        }
        else {
            throw new common_1.UnauthorizedException();
        }
    }
    async deleteAccount(res, req) {
        if (req.user.isUser === true) {
            let token = req.headers.authorization.split(' ')[1];
            let isValid = await this.commonServices.checkToken(token);
            if (isValid === false) {
                throw new common_1.UnauthorizedException();
            }
            return this.userService.deleteAccount(req.user.userId, res);
        }
        else {
            throw new common_1.UnauthorizedException();
        }
    }
    async socialLogin(data, res, req) {
        return this.userService.socialLogin(data, res);
    }
};
exports.UserController = UserController;
__decorate([
    (0, common_1.Post)('/registerUser'),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, common_1.Res)()),
    __param(2, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_user_dto_1.CreateUserDto, Object, Object]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "registerUser", null);
__decorate([
    (0, common_1.Post)('/userLogin'),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, common_1.Res)()),
    __param(2, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_user_dto_1.CreateUserDto, Object, Object]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "userLogin", null);
__decorate([
    (0, common_1.Post)('/forgotPassword'),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, common_1.Res)()),
    __param(2, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_user_dto_1.CreateUserDto, Object, Object]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "forgotPassword", null);
__decorate([
    (0, common_1.Post)('/verifyOtp'),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, common_1.Res)()),
    __param(2, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_user_dto_1.CreateUserDto, Object, Object]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "verifyOtp", null);
__decorate([
    (0, common_1.Post)('/changePassword'),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, common_1.Res)()),
    __param(2, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_user_dto_1.CreateUserDto, Object, Object]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "changePassword", null);
__decorate([
    (0, common_1.UseGuards)((0, passport_1.AuthGuard)('jwt')),
    (0, common_1.UseInterceptors)((0, platform_express_1.FileInterceptor)('profile_image', {
        storage: (0, multer_1.diskStorage)({
            destination: function (req, file, cb) {
                if (file?.fieldname === 'profile_image') {
                    if (!file.mimetype.match(/\/(jpg|jpeg|png|gif|jfif)$/)) {
                        cb(new common_1.HttpException(`Unsupported file type ${(0, path_1.extname)(file.originalname)}`, common_1.HttpStatus.BAD_REQUEST), 'false');
                    }
                }
                cb(null, process.env.IMAGE_PATH);
            },
            filename: async (req, file, callback) => {
                const extName = (0, path_1.extname)(file.originalname);
                const FinalPath = file.fieldname + '-' + Date.now() + extName;
                callback(null, FinalPath);
            },
        }),
    })),
    (0, common_1.Post)('/updateProfile'),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, common_1.UploadedFile)()),
    __param(2, (0, common_1.Res)()),
    __param(3, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_user_dto_1.CreateUserDto, Object, Object, Object]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "updateProfile", null);
__decorate([
    (0, common_1.UseGuards)((0, passport_1.AuthGuard)('jwt')),
    (0, common_1.Post)('/logout'),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, common_1.Res)()),
    __param(2, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_user_dto_1.CreateUserDto, Object, Object]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "logout", null);
__decorate([
    (0, common_1.UseGuards)((0, passport_1.AuthGuard)('jwt')),
    (0, common_1.Post)('/deleteAccount'),
    __param(0, (0, common_1.Res)()),
    __param(1, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "deleteAccount", null);
__decorate([
    (0, common_1.Post)('/socialLogin'),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, common_1.Res)()),
    __param(2, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "socialLogin", null);
exports.UserController = UserController = __decorate([
    (0, common_1.Controller)('user'),
    __metadata("design:paramtypes", [user_service_1.UserService,
        commonServices_1.commonServices])
], UserController);
//# sourceMappingURL=user.controller.js.map